<?php



//	require_once(ABSPATH . 'wp-admin/includes/media.php');
	require_once(ABSPATH . 'wp-includes/pluggable.php');
 


	/*
	**	To overwrite these default field types, use the 'more_fields_field_types' filter
	**
	*/	
	function more_fields_field_types () {
		
		$f = array();

		/*
		**	TEXT
		*/
		$f['text']['label'] = __('Text', 'more-plugins');
		$f['text']['html_item'] = '<label for="%key%">%title%</label> <input class="%class%" type="text" name="%key%" value="%value%" /> %caption%';
		$f['text']['comment'] = __('Creates a simple one line text input box.', 'more-plugins');

		/*
		**	TEXTAREA
		*/
		$f['textarea']['label'] = __('Textarea', 'more-plugins');
		$f['textarea']['html_item'] = "<label for='%key%'>%title%</label> <textarea class='%class%' name='%key%'>%value%</textarea> %caption%";
		$f['textarea']['comment'] = __('Creates a plain text box.', 'more-plugins');
		
		/*
		**	WYSIWYG
		*/	
		$f['wysiwyg']['label'] = __('WYSIWYG', 'more-plugins');
		$f['wysiwyg']['html_before'] = '		   
		   <script type="text/javascript">
			   /* <![CDATA[ */
			   jQuery(document).ready( function () { 
				   jQuery("#%key%").addClass("mceEditor");
				   		if ( typeof( tinyMCE ) == "object" && typeof( tinyMCE.execCommand ) == "function" ) {
							tinyMCE.settings.theme_advanced_buttons1 += ",|,add_image,add_video,add_audio,add_media";	
				   			tinyMCE.execCommand("mceAddControl", false, "%key%");
				   }
			   }); 
			   /* ]]> */
			   </script>
			   <div style="width: 100%">
			   <label class="mf_wysiwig" for="%key%">%title%</label>
		   <textarea class="%class% %key%" name="%key%" id="%key%">' . "\n";
// ed.settings.theme_advanced_buttons1 += ',|,add_image,add_video,add_audio,add_media';		   
//		$f['wysiwyg']['html_before'] = '<textarea class="%class% %key%" name="%key%" id="%key%">' . "\n";
		add_action('mf_the_editor', 'the_editor', 10, 2);
		// function the_editor($content, $id = 'content', $prev_id = 'title', $media_buttons = true, $tab_index = 2) {
//		$f['wysiwyg']['actions'] = array('mf_the_editor' => array( '%value%', '%key%'));
//		$f['wysiwyg']['html_item'] = "%value%";
		$f['wysiwyg']['html_after'] = "</textarea></div>\n %caption%";
		$f['wysiwyg']['comment'] = __('Creates text box that allows formatted input. WYSIWYG - What you see is what you get', 'more-plugins');

		/*
		**	SELECT
		*/	
		$f['select']['label'] = __('Select', 'more-plugins');
		$f['select']['html_before'] = "<label for='%key%'>%title%</label> <select class='%class%' name='%key%'>\n";
		$f['select']['html_item'] = "<option value='%value%' %selected%>%value%</option>";
		$f['select']['html_after'] = "</select>\n %caption% \n";
		$f['select']['html_selected'] = 'selected="selected"';
		$f['select']['values'] = true; 
		$f['select']['comment'] = __('Creates a select list, with elements with the names/values as specified below', 'more-plugins');

		/*
		**	RADIOBUTTON
		*/
		$f['radio']['label'] =  __('Radio', 'more-plugins');
		$f['radio']['html_item'] = "<label class='mf_radio'><input class='%class%' type='radio' name='%key%' value='%value%' %selected%> %value%</label>";
		$f['radio']['html_after'] = "%caption%";
		$f['radio']['html_selected'] = 'checked="checked"';
		$f['radio']['values'] = true;
		$f['radio']['comment'] = __('Creates a radio button list, where the user can only select one value. The list of values is specifed below.', 'more-plugins');

		/*
		**	CHECKBOX
		*/
		$f['checkbox']['label'] =  __('Checkbox', 'more-plugins');
		$f['checkbox']['html_item'] = "<label class='mf_check'><input class='%class%' type='checkbox' id='%key%' name='%key%' %selected% value='checkbox_on'> %title%</label>";
		$f['checkbox']['html_selected'] = 'checked="checked"';
		$f['radio']['html_after'] = "%caption%";
		$f['checkbox']['values'] = false;
		$f['checkbox']['comment'] = __('Creates single checkbox, which key is either on/off.', 'more-plugins');

		/*
		**	FILE LIST
		*/		
		$f['file-list']['label'] = __('File list', 'more-plugins');
		$f['file-list']['html_item'] = "		
			<input type='hidden' id='%key%' name='%key%' value='%value%'>
			<div class='mf_file_list_show' id='mf_file_list_show_%key%'>
				<a href='%value%'>%value%</a> <input type='button' class='button file_list_update' id='mf_file_list_edit_button_%key%' value='Edit' />
			</div>
			<div class='mf_file_list_edit' id='mf_file_list_edit_%key%'>
				<label class='mf_filelist'>	
					<select class='%class% mf_file_list_select' type='checkbox' id='%key%_temp' name='%key%' %selected%></select> 
					<input type='button' class='button file_list_update' id='mf_file_list_update_button_%key%' value='Update list' /> 
				</label>
			</div>
			";
		$f['file-list']['html_selected'] = 'checked="checked"';
		$f['file-list']['html_after'] = '%caption%';
		$f['file-list']['values'] = true;
		$f['file-list']['comment'] = __('Select files from posts media library.', 'more-plugins');
				
	/*
	****	HTML5
	*/

		/*
		**	COLOR
		*/
		$text = __('<a href="http://www.w3.org/TR/css3-color/#html4"><code>color keyword</code></a>, rgb(a) or HEX', 'more-plugins');
		$f['color']['label'] = __('Color', 'more-plugins');
		$f['color']['html_after'] = "<label class='mf_color' for='%key%'>%title%</label> <input type='color' class='mf_update_on_edit mf_color input-color' id='%key%' name='%key%' value='%value%' /> <b>value</b> <small>$text</small> %caption%";
		$f['color']['values'] = false;
		$f['color']['comment'] = __('HTML5 input type, full functionality available in modern browsers. Alternative input values can be <a href="http://www.w3.org/TR/css3-color/#html4"><code>color keyword</code></a>, <code>rgba(255, 255, 255, 1.0)</code>, <code>#ffffff</code> or <code>#fff</code>', 'more-plugins');

		/*
		**	RANGE
		*/
		$text = __('Range', 'more-types');
		$f['range']['label'] = __('Number range', 'more-plugins');
		$f['range']['html_after'] = "<label class='mf_range' for='%key%'>%title%</label> <input class='mf_update_on_edit mf_range input-range' type='range' min='%min%' max='%max%' id='%key%' name='%key%' value='%value%' /> <b>%value%</b> <small>$text</small> %caption%";
		$f['range']['values'] = true;
		$f['range']['comment'] = __('HTML5 input type, full functionality available in modern browsers. Alternative input: numerical in the range specified below.', 'more-plugins');

		/*
		**	NUMBER
		*/
		$text = __('Number', 'more-plugins');
		$f['number']['label'] = __('Number', 'more-plugins');
		$f['number']['html_after'] = "<label class='mf_number' for='%key%'>%title%</label> <input class='mf_update_on_edit mf_number input-number' type='number' min='%min%' max='%max%' id='%key%' name='%key%' value='%value%' /> <b>%value%</b> <small>$text</small> %caption%";
		$f['number']['values'] = true;
		$f['number']['comment'] = __('HTML5 input type, full functionality available in modern browsers. Alternative input: numerical in the range specified below.', 'more-plugins');

		/*
		**	TIME
		*/
		$text = __('<code>HH:ii</code>, i.e <code>13:37</code>', 'more-plugins');
		$f['time']['label'] = __('Time', 'more-plugins');
		$f['time']['html_after'] = "<label class='mf_time' for='%key%'>%title%</label> <input class='mf_update_on_edit mf_time input-time' type='time' id='%key%' name='%key%' value='%value%' /> <b>%value%</b> <small>$text</small> %caption%";
		$f['time']['values'] = false;
		$f['time']['comment'] = __('HTML5 input type, full functionality available in modern browsers. Alternative input: HH:ii, i.e <code>13:37</code>', 'more-plugins');		

		/*
		**	MONTH
		*/
		$text = __('<code>YYYY-mm</code>, i.e <code>2010-07</code>', 'more-plugins');
		$f['month']['label'] = __('Month', 'more-plugins');
		$f['month']['html_after'] = "<label class='mf_month' for='%key%'>%title%</label> <input class='mf_update_on_edit mf_month input-month' type='month' id='%key%' name='%key%' value='%value%' /> <b>%value%</b> <small>$text</small>  %caption%";
		$f['month']['values'] = false;
		$f['month']['comment'] = __('HTML5 input type, full functionality available in modern browsers. Alternative input: YYYY-mm, i.e <code>2010-07</code>', 'more-plugins');

		/*
		**	WEEK
		*/
		$text = __('<code>YYYY-WWW</code>, i.e <code>2010-W29</code>', 'more-plugins');
		$f['week']['label'] = __('Week', 'more-plugins');
		$f['week']['html_after'] = "<label class='mf_week' for='%key%'>%title%</label> <input class='mf_update_on_edit mf_week input-week' type='week' id='%key%' name='%key%' value='%value%' /> <b>%value%</b> <small>$text</small> %caption%";
		$f['week']['values'] = false;
		$f['week']['comment'] = __('HTML5 input type, full functionality available in modern browsers. Alternative input: YYYY-WWW, i.e <code>2010-W27</code>', 'more-plugins');		

		/*
		**	DATE
		*/
		$text = __('<code>YYYY-mm-dd</code>, i.e <code>2010-07-19</code>', 'more-plugins');
		$f['date']['label'] = __('Date', 'more-plugins');
		$f['date']['html_after'] = "<label class='mf_date' for='%key%'>%title%</label> <input class='mf_update_on_edit mf_date input-date' type='date' id='%key%' name='%key%' value='%value%' /> <b>%value%</b> <small>%caption%</small> %caption%";
		$f['date']['values'] = false;
		$f['date']['comment'] = __('HTML5 input type, full functionality available in modern browsers. Alternative input: YYYY-mm-dd, i.e <code>2010-07-10</code>', 'more-plugins');

		
		return $f;
	}
	add_filter('more_fields_field_types', 'more_fields_field_types');
	
	
	function more_fields_css () {
	$css = '
		.mf_label
		{ 
			display: block; 
			margin-left: 2px; 
		}
		.mf_text
		{ 
			width: 95%; 
			margin-left: 1px; 
		}
		.mf_textarea
		{ 
			width: 95%; 
			margin-left: 1px; 
			height: 150px;
		}
		.mf_select
		{
			width: 96%; 
		}
		.wrap #post-body h2
		{
			clear: none;
		}
		.inside .mceResize
		{
			margin-top: -45px !important;
		}
		.inside .mceEditor iframe
		{
			border-left: 1px solid #dfdfdf;
			border-right: 1px solid #dfdfdf;
			box-sizing: border-box;
			-moz-box-sizing:border-box; /* Mozilla: Change Box Model Behaviour */
		}
		';
		return $css;
	}	
	
	add_filter('more_fields_css', 'more_fields_css');

?>